package component

import AddStudent
import csstype.Display
import csstype.Flex
import emotion.react.css
import react.*
import react.dom.html.ReactHTML.details
import react.dom.html.ReactHTML.div
import react.dom.html.ReactHTML.summary
import react.router.Route
import react.router.Routes
import react.router.dom.HashRouter
import react.router.dom.Link
import redux.markReducer
import redux.testState

val shortOutput = createContext("Full")

val app = FC<Props>("App") {
    val (mode, setMode) = useState("Full")
    val (state, dispatch) = useReducer(markReducer, testState())
    CModePicker {
        _mode = mode
        _setMode = setMode
    }
    shortOutput.Provider(mode) {
        HashRouter {
            div {
                css {
                    display = Display.flex
                }
                state.courses.forEach { course ->
                    val name = course.name
                    Link {
                        css {
                            flex = Flex.minContent
                        }
                        +name
                        to = name
                    }
                }
            }
            details {
                summary{ +"Add Student"}
                CAddStudent {
                    add = { student ->
                        dispatch(AddStudent(student))
                    }
                }
            }
            Routes {
                Route {
                    path = ":name"
                    element = CCoursePicker.create {
                        this.state = state
                        this.dispatch = dispatch
                    }
                }
            }
        }
    }
}